#define RANKHOST 0
#define I_AM_HOST (rank==RANKHOST)
#define min(A,B) ((A) < (B) ? (A) : (B))
#define max(A,B) ((A) > (B) ? (A) : (B))
#define MMX 120
#define MMY 120
#define MMZ 120
#define NCELL (MMX*MMY*MMZ)
#define NMAX  50200000
#define NMAX2 50200000
#define SCRSIZ 6*NMAX2
#define MYBUFSIZ 524288
#define MAXLST 2048
#define INSIZE 1000
#define INREAL 6*INSIZE
#define MAXPAS 256000/4
#define FOR1 0
#define FOR2 NMAX2
#define FOR3 (2*NMAX2)
#define OPSIZ (SCRSIZ/6)
#define OP1 0
#define OP2 OPSIZ
#define OP3 (2*OPSIZ)
#define OP4 (3*OPSIZ)
#define OP5 (4*OPSIZ)
#define OP6 (5*OPSIZ)


void cold_start(int, float*, float*, float*, float*, float*, float*, int, int, int, float, float, float, int*);
void loop_initialise (int);
void movout (float*, float*, float*, float*, float*, float*, int*, int*, int, int, int, int*);
void force (float*, float*, float*, float*, float*, int*, int*, int);
void movea (float*, float*, float*, float*, float*, float*, int);
void outcon (int, int, int, float*, float*, float*, float*, float*, float*, float, float, float, int);
void moveb (float*, float*, float*, float*, int);
void sum_energies (float, float, float);
void hloop (float, int, int, float*, float*, float*, int);
void tidyup ();
int read_input (float*);
void set_nearest_cells ();
void set_chunk (int*, int, int*, int*, int*, int*);
void initialise_particles (int*, int*, int*, int*, float*, float*, float*, float*, float*, float*, float, float, float);
void pseudorand(int*, float*);
void flush_buffer(float*, float, int*, int*, int*, int*, float*, float*, float*, float*, float*, float*, float, float, float);
void pack_buffer (int, int*, int*, int*, int*, float, float, float, float, float, float, float*, float*, float*, float*, float*, float*, float, float, float);
void tohost (float*, int, int*, float*, float*, float*, float*, float*, float*, float, float, float);
void savcon (int, int, int, float*, float*, float*, float*, float*, float*, float, float, float);
void migrate_buffer (int, int, int, int*, float*, int*, float*, float*, float*, float*, float*, float*, int*, int*, int*);
void edgbuf (int, int, int, int, int, int, int, int*, float*, float*, float*, float*, int*, int*);
void pasbuf(int, int, int*, int*, float*, float*, float, float, float, float*, float*, float*, int*, int*);
void lstadd (int, float*, float*, float*, float*, float*, float*, float*, int*, int*, int*);
void edgadd (int*, int*, float*, float*, float*, float*, int*, int*);
void scalet (float, float*, float*, float*, int, int);
void edgprint (int, int, int, int, int, int, float*, float*, float*, int*, int*);
